<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "patientemail_batch".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PatientemailBatch".
 *
 * Columns in table "patientemail_batch" available as properties of the model,
 * followed by relations of table "patientemail_batch" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property integer $practice_id
 * @property integer $account_device_id
 * @property string $link_type
 * @property string $template
 * @property string $description
 * @property string $custom_title
 * @property string $custom_body
 * @property string $custom_link
 * @property string $date_added
 * @property string $date_updated
 *
 * @property Patientemail[] $patientemails
 * @property Account $account
 * @property Practice $practice
 * @property AccountDevice $accountDevice
 */
abstract class BasePatientemailBatch extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'patientemail_batch';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PatientemailBatch|PatientemailBatches', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('account_id, practice_id, date_added, date_updated', 'required'),
            array('account_id, practice_id, account_device_id', 'numerical', 'integerOnly'=>true),
            array('link_type', 'length', 'max'=>6),
            array('template, description, custom_title', 'length', 'max'=>50),
            array('custom_body', 'length', 'max'=>200),
            array('custom_link', 'length', 'max'=>255),
            array('account_device_id, link_type, template, description, custom_title, custom_body, custom_link', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, account_id, practice_id, account_device_id, link_type, template, description, custom_title, custom_body, custom_link, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'patientemails' => array(self::HAS_MANY, 'Patientemail', 'patientemail_batch_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'accountDevice' => array(self::BELONGS_TO, 'AccountDevice', 'account_device_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => null,
            'practice_id' => null,
            'account_device_id' => null,
            'link_type' => Yii::t('app', 'Link Type'),
            'template' => Yii::t('app', 'Template'),
            'description' => Yii::t('app', 'Description'),
            'custom_title' => Yii::t('app', 'Custom Title'),
            'custom_body' => Yii::t('app', 'Custom Body'),
            'custom_link' => Yii::t('app', 'Custom Link'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'patientemails' => null,
            'account' => null,
            'practice' => null,
            'accountDevice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('account_device_id', $this->account_device_id);
        $criteria->compare('link_type', $this->link_type, true);
        $criteria->compare('template', $this->template, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('custom_title', $this->custom_title, true);
        $criteria->compare('custom_body', $this->custom_body, true);
        $criteria->compare('custom_link', $this->custom_link, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
